# generic_form_field
![MacDown logo](./images/insane_developer.png)

Un widget para búsqueda y selección dentro de un [Form](https://docs.flutter.io/flutter/widgets/Form-class.html).

### Importar *package*
~~~dart
import 'package:generic_form_field/generic_form_field.dart';
~~~

### Crear _callback_ y campo de formulario
~~~dart
User _user;
Future<List<User>> _find(String text) async => await Routes.users();
...
GenericFormField<User>(
	minimumLenghtRequired: 0,
	dialogTitle: 'User',
	decoration: InputDecoration(labelText: 'User'),
	searchCallback: _find,
	initialValue: _user,
	validator: (u) => u == null ? 'Must select a user' : null,
	onSaved: (u) => setState(() => _user = u),
),
~~~
### Resultado
![screenshot](./images/Screenshot02.png)
![screenshot](./images/Screenshot04.png)